#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <strings.h>

static
int outchars(char *ptr, int chars)
{
  int i;

  for (i=0; i<chars; i++) {
      if (*ptr >= 0x20) putchar(*ptr++);
      else { putchar(' '); ptr++; }
  }

  return chars;
}

int main(int argc, char **argv)
{
  unsigned char 
    thing[1024], *ptr = thing;

  FILE *fp;
  int samples;
  int pointer = 0xef;

  if (argc < 2) {
  	fprintf(stderr, "Filename w肵ĉB\n");
  	exit(-1);
  }

  fp = fopen(argv[1],"rb");

  if (fp == NULL) {
  	fprintf(stderr, "File  open ł܂B\n");
  	exit(-1);
  }

  fread(thing, 1, 1024, fp);

  printf("Header\t\t: ");			  /* header */
  ptr += outchars(ptr, 11);
  printf("\n");
  ptr++;

  printf("ID\t\t: ");				  /* Gravis ID */
  ptr += outchars(ptr, 9);
  printf("\n");
  ptr++;

  printf("copyright\t: ");			  /* description */
  ptr += outchars(ptr, 60);
  printf("\n");

#define L16(x) (                                     (*(x+1))*256 + *(x))
#define L32(x) ((*(x+3))*16777216 + (*(x+2))*65536 + (*(x+1))*256 + *(x))

  printf("instruments(1)\t: %d\n", *ptr++);
  printf("voices(14)\t: %d\n", *ptr++);
  printf("channels?\t: %d\n", *ptr++);
  printf("wave \t\t: %d\n", L16(ptr)); ptr +=2;
  printf("mastervol(127)\t: %d\n", L16(ptr)); ptr +=2;
  printf("f[^TCY\t: %d bytes\n", L32(ptr)); ptr +=4;
  ptr +=36; /* reserverd area? */
  
  printf("instrument #\t: %d\n", L16(ptr)); ptr +=2;

  /* instrument name */

  printf("y햼\t\t: ");
  ptr += outchars(ptr, 16);
  printf("\n");

  printf("yf[^TCY: %d bytes\n", L32(ptr)); ptr +=4;
  printf("layers (1)\t: %d\n", *ptr++);
  ptr +=40; /* reserverd area? */

  printf("layer duplicate\t: %d\n", *ptr++);
  printf("layer\t\t: %d\n", *ptr++);
  printf("layer size\t: %d bytes\n", L32(ptr)); ptr +=4;
  samples = *ptr++;
  printf("wave \t\t: %d\n", samples);
  ptr +=40; /* reserverd area? */

  /* === each sampling data === */

 do {

  printf("--------\n");

  fseek(fp, pointer, SEEK_SET);
  fread(thing, 1, 1024, fp);
  ptr = thing;

  /* wave name */

  printf("wave \t\t: ");
  ptr += outchars(ptr, 6);
  printf("\n");
  ptr++;

  printf("fractions\t: %d\n", *ptr++);
  pointer += L32(ptr) + 96;
  printf("wave TCY\t: %d bytes\n", L32(ptr)); ptr +=4;
  printf("[vJnʒu\t: %d\n", L32(ptr)); ptr +=4;
  printf("[vIʒu\t: %d\n", L32(ptr)); ptr +=4;
  printf("W{g\t: %dHz\n", L16(ptr)); ptr +=2;
  printf("g\t: %.3f ` %.3fHz\n", (float)L32(ptr)/1000, (float)L32(ptr+4)/1000); ptr +=8;
  printf("{g\t: %.3f Hz\n", (float)L32(ptr)/1000); ptr +=4;
  printf("detune\t\t: %d\n", *ptr++);
  printf("IN^[u (2)\t: %d\n", *ptr++);
  printf("oX (7=mid): %d\n", *ptr++);

  printf("envelope rates\t: %d %d %d %d %d %d\n", *ptr++, *ptr++, *ptr++, *ptr++, *ptr++, *ptr++);
  printf("envelope offsets: %d %d %d %d %d %d\n", *ptr++, *ptr++, *ptr++, *ptr++, *ptr++, *ptr++);

  printf("tremolo sweep\t: %d\n", *ptr++);
  printf("tremolo rate\t: %d\n", *ptr++);
  printf("tremolo depth\t: %d\n", *ptr++);
  printf("vibrato sweep\t: %d\n", *ptr++);
  printf("vibrato rate\t: %d\n", *ptr++);
  printf("vibrato depth\t: %d\n", *ptr++);

  printf("modes\t\t: %d\n", *ptr);
  printf("\t\t: envelope scaling\t%d\n", ((*ptr & 0xc0) >> 6) & 3);
  printf("\t\t: sound variation\t%s\n", (*ptr & 0x20) == 0x20 ? "melodic" : "percussion" );
  printf("\t\t: read sample\t\t%s\n", (*ptr & 0x10) == 0x10 ? "backward" : "forward" );
  printf("\t\t: loop\t\t\t%s\n", (*ptr & 0x4) == 0x4 ? "looped" : "once" );
  printf("\t\t: quantize\t\t%s\n", (*ptr++ & 0x1) ? "16bit" : "8bit" );
  printf("scale freq\t: %d\n", L16(ptr)); ptr +=2;
  printf("scale factor\t: %d\n", L16(ptr)); ptr +=2;

 } while (--samples > 0);

  fclose(fp);

  return 0;
}
